# coding: utf-8

"""
    Looker API 3.0 Reference

    ### Authorization  The Looker API uses Looker **API3** credentials for authorization and access control. Looker admins can create API3 credentials on Looker's **Admin/Users** page. Pass API3 credentials to the **/login** endpoint to obtain a temporary access_token. Include that access_token in the Authorization header of Looker API requests. For details, see [Looker API Authorization](https://looker.com/docs/r/api/authorization)  ### Client SDKs  The Looker API is a RESTful system that should be usable by any programming language capable of making HTTPS requests. Client SDKs for a variety of programming languages can be generated from the Looker API's Swagger JSON metadata to streamline use of the Looker API in your applications. A client SDK for Ruby is available as an example. For more information, see [Looker API Client SDKs](https://looker.com/docs/r/api/client_sdks)  ### Try It Out!  The 'api-docs' page served by the Looker instance includes 'Try It Out!' buttons for each API method. After logging in with API3 credentials, you can use the \"Try It Out!\" buttons to call the API directly from the documentation page to interactively explore API features and responses.  ### Versioning  Future releases of Looker will expand this API release-by-release to securely expose more and more of the core power of Looker to API client applications. API endpoints marked as \"beta\" may receive breaking changes without warning. Stable (non-beta) API endpoints should not receive breaking changes in future releases. For more information, see [Looker API Versioning](https://looker.com/docs/r/api/versioning) 

    OpenAPI spec version: 3.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class GitStatus(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, action=None, text=None, revertable=None, conflict=None, can=None):
        """
        GitStatus - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'action': 'str',
            'text': 'str',
            'revertable': 'bool',
            'conflict': 'bool',
            'can': 'dict(str, bool)'
        }

        self.attribute_map = {
            'action': 'action',
            'text': 'text',
            'revertable': 'revertable',
            'conflict': 'conflict',
            'can': 'can'
        }

        self._action = action
        self._text = text
        self._revertable = revertable
        self._conflict = conflict
        self._can = can

    @property
    def action(self):
        """
        Gets the action of this GitStatus.
        Git action: add, delete, etc

        :return: The action of this GitStatus.
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """
        Sets the action of this GitStatus.
        Git action: add, delete, etc

        :param action: The action of this GitStatus.
        :type: str
        """

        self._action = action

    @property
    def text(self):
        """
        Gets the text of this GitStatus.
        Git description of the action

        :return: The text of this GitStatus.
        :rtype: str
        """
        return self._text

    @text.setter
    def text(self, text):
        """
        Sets the text of this GitStatus.
        Git description of the action

        :param text: The text of this GitStatus.
        :type: str
        """

        self._text = text

    @property
    def revertable(self):
        """
        Gets the revertable of this GitStatus.
        When true, the file can be reverted to an earlier state

        :return: The revertable of this GitStatus.
        :rtype: bool
        """
        return self._revertable

    @revertable.setter
    def revertable(self, revertable):
        """
        Sets the revertable of this GitStatus.
        When true, the file can be reverted to an earlier state

        :param revertable: The revertable of this GitStatus.
        :type: bool
        """

        self._revertable = revertable

    @property
    def conflict(self):
        """
        Gets the conflict of this GitStatus.
        When true, changes to the local file conflict with the remote repository

        :return: The conflict of this GitStatus.
        :rtype: bool
        """
        return self._conflict

    @conflict.setter
    def conflict(self, conflict):
        """
        Sets the conflict of this GitStatus.
        When true, changes to the local file conflict with the remote repository

        :param conflict: The conflict of this GitStatus.
        :type: bool
        """

        self._conflict = conflict

    @property
    def can(self):
        """
        Gets the can of this GitStatus.
        Operations the current user is able to perform on this object

        :return: The can of this GitStatus.
        :rtype: dict(str, bool)
        """
        return self._can

    @can.setter
    def can(self, can):
        """
        Sets the can of this GitStatus.
        Operations the current user is able to perform on this object

        :param can: The can of this GitStatus.
        :type: dict(str, bool)
        """

        self._can = can

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, GitStatus):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
